"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.EventStream = void 0;
const events_1 = require("events");
class EventStream {
    constructor() {
        this.publish = (event) => {
            this.emitter.emit('event', event);
        };
        this.subscribe = ({ consumer }) => {
            // subscribe consumer to topic
            this.emitter.on('event', consumer);
        };
        this.unsubscribe = ({ consumer }) => {
            // unsubscribe consumer from topic
            this.emitter.removeListener('event', consumer);
        };
        this.emitter = new events_1.EventEmitter();
    }
}
exports.EventStream = EventStream;
//# sourceMappingURL=index.js.map